clc;
clear all;

DataPath='..\T2FJSP_instances\';
J={20,30,40,50,80,100};
M1={6,7,8,9,10};
name='Type2FJSP';line='_';txt='.txt';J_name='J';M_name='M';

[~,m]=size(J);[~,n]=size(M1);k=1;
for i=1:m
    for j=1:n
        RealPath{k}=[DataPath,name,line,num2str(J{i}),line,num2str(M1{j}),txt];
        ResultPath{k}=[J_name,num2str(J{i}),M_name,num2str(M1{j})];
        k=k+1;
    end
end
%RealPath=[DataPath,name,line,num2str(J{1}),line,num2str(M{1}),txt];

global  N H SH NM ps M TM time refpoint Archive_PF;
T=[5,10,15,20];%ȡֵΧ
fout=fopen('parameter.txt','r');
A=fscanf(fout,'%d %f %f %f');
fclose(fout);
ps=A(1);%ȺС;
gamma=A(2);%ۿ
alpha=A(3);%ѧϰ
epsilon=A(4);%̰

for File=24:30
    [N,TM,H,NM,M,SH,time]=DataRead(RealPath{File});
     
    respath='result\';
    tmp6='\';
    respath=[respath,ResultPath{File},tmp6];
    %޹ر
    clear tmp6
    a=['mkdir ' respath];%дļ
    system(a);%Windowsִdos
    fprintf('%s %s\r\n','Calculating ',RealPath{File});
    for round=1:10   
    [weights,neighbour]=init_weight(ps+1,2,20);    % ʼȨ ps1Ϊ˱֤Ȩ0  
    [p_chrom,m_chrom]=initialmix5();
    
    fitness=cell(ps,2);
    for i=1:ps
        [fitness{i,1},fitness{i,2}]=fit(p_chrom(i,:),m_chrom(i,:));
    end
    obj=finalvalue(fitness);
    [refpoint,~]=min(obj);             % ʼο,οΪиĸĿ꺯ֵеСֵ
    
    RP=[[0,0],[5,0],[10,0],[0,5],[0,10]];%GDָҪĲο
    Qtable=zeros(4,4);
    currt_State=1;next_State=1;%ǰ״̬
    last_Cv=1;currt_Cv=1;delt_Cv=1;%ǰ,һ,һ,仯
    last_Dv=0;currt_Dv=0;delt_Dv=1;%ǰķֲ,һ,һ,仯
    %archive for PF
    Archive_PF=[];
    
    for i=1:200 %
     fprintf('%s %s %d %s %d\r\n',RealPath{File},'round',round,'iter',i);
     last_Cv=currt_Cv;last_Dv=currt_Dv;
     currt_State=getState(delt_Cv,delt_Dv);
     %choose action
     if rand>epsilon||all(Qtable(currt_State,:)==0)
         action=ceil(rand*4); 
     else
         [~,action]=max(Qtable(currt_State,:));
     end
     
      for j=1:ps
        select_T=T(action);
        [new_p1,new_m1,new_p2,new_m2]= evolution(p_chrom,m_chrom,neighbour,j,select_T);
        f1=cell(1,2);
        f2=cell(1,2);
        [f1{1,1},f1{1,2}]=fit(new_p1,new_m1);
        [f2{1,1},f2{1,2}]=fit(new_p2,new_m2);
        if(i>100)%ں100ſʼֲɼԴ˷
            [new_p1,new_m1,f1]=VNS(new_p1,new_m1,f1);%ִб
            [new_p2,new_m2,f2]=VNS(new_p2,new_m2,f2);      
            [new_p1,new_m1,f1]=EnergySave2(new_p1,new_m1,f1);%ִ洢
            [new_p2,new_m2,f2]=EnergySave2(new_p2,new_m2,f2);
        end
        zz1=finalvalue(f1);
        zz2=finalvalue(f2);
        refpoint=min(refpoint,zz1);
        refpoint=min(refpoint,zz2);
        nei=neighbour(j,:);
        for t=1:select_T
            k=nei(t);%ȡھ 
            tmp{1,1}=fitness{k,1};
            tmp{1,2}=fitness{k,2};
            zzold=finalvalue(tmp);
            [p_chrom(k,:),m_chrom(k,:),flag]=updates(weights(k,:),p_chrom(k,:),m_chrom(k,:),new_p1,new_m1,zzold,zz1);  % ⣬ע⴫Ĳ
            if flag==1
                fitness{k,1}=f1{1,1};
                fitness{k,2}=f1{1,2};
            end
        end
        
        for t=1:select_T
            k=nei(t);
            tmp{1,1}=fitness{k,1};
            tmp{1,2}=fitness{k,2};
            zzold=finalvalue(tmp);
            [p_chrom(k,:),m_chrom(k,:),flag]=updates(weights(k,:),p_chrom(k,:),m_chrom(k,:),new_p2,new_m2,zzold,zz2);  % ⣬ע⴫Ĳ
            if flag==1%Ӧֵ ٽӦֵ
                fitness{k,1}=f2{1,1};
                fitness{k,2}=f2{1,2};
            end
        end
      end%jѭ
      [AS]=pareto(fitness);
    L=length(AS);
    obj=finalvalue(fitness);
    newobj=[];
    for j=1:L
        newobj(j,:)=obj(AS(j),:);   
    end
    newobj=unique(newobj,'rows');%ɾظ
    [obj_size,~]=size(newobj);
    Archive_PF=[Archive_PF;newobj];
    [AS]=pareto2(Archive_PF);
    Archive_PF=Archive_PF(AS,:);
    DeleteRpeat();
    currt_Cv=convergence(newobj,RP);delt_Cv=last_Cv-currt_Cv;
    currt_Dv=diversity(newobj);delt_Dv=currt_Dv-last_Dv;
    %update Qtable
    if delt_Dv>0
        reward=10;
    else
        reward=0;
    end
    next_State=getState(delt_Cv,delt_Dv);
    maxreward=max(Qtable(next_State,:));%ҵһ״̬Ļر ʾеĶǿܵĶ
    Qtarget=reward+gamma*maxreward;   %Qһ״̬Ĺֵ
    Qtable(currt_State,action)=Qtable(currt_State,action)+alpha*(Qtarget- Qtable(currt_State,action));%Q
    end
[AS]=pareto2(Archive_PF);
L=length(AS);
newobj=[];
for i=1:L
    newobj(i,:)=Archive_PF(AS(i),:);   
end
    newobj=unique(newobj,'rows');%ɾظ
    tmp5=newobj';%õǰؽ⼯ת
    %scatter(newobj(:,1),newobj(:,2));
    tmp1='res';%ַд洢·
    resPATH=[respath tmp1 num2str(round) txt];
    fout=fopen(resPATH,'w');
    fprintf(fout,'%5.2f %6.3f\r\n',tmp5);%matlabǰд洢ͶȡдļʱҲǰдҪתô
    fclose(fout);
    end
end